package com.jpsoft.smart.modules.base.dao;
import org.apache.ibatis.annotations.Param;

import com.jpsoft.smart.modules.base.entity.PersonDeviceFilterLog;
import com.jpsoft.smart.modules.base.entity.PersonDeviceLog;
import com.jpsoft.smart.modules.base.entity.PersonInfo;
import com.jpsoft.smart.modules.common.dto.Sort;
import org.springframework.stereotype.Repository;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @author 墨鱼_mo
 * @date 2020-3-20 9:20
 */
@Repository
public interface PersonDeviceFilterLogDAO {

    void insert(PersonDeviceFilterLog personDeviceFilterLog);


    PersonDeviceFilterLog findByPersonIdAndDeviceNoAndTimeZones(@Param("personId") Integer personId, @Param("deviceNo") String deviceNo, @Param("timeZones") String timeZones);

    int update(PersonDeviceFilterLog personDeviceFilterLog);

    List<PersonDeviceFilterLog> search(Map<String, Object> searchParams, List<Sort> sortList);

    List<PersonDeviceFilterLog> findByPersonAndDate(@Param("personId") Long personId, @Param("startDate")String startDate, @Param("endDate")String endDate);

    List<PersonDeviceFilterLog> temperatureNormalStatistics(@Param("temperature")BigDecimal temperature, @Param("startDate")String startDate, @Param("endDate")String endDate);

    List<PersonDeviceFilterLog> temperatureUnusualStatistics(@Param("temperature")BigDecimal temperature,@Param("startDate")String startDate, @Param("endDate")String endDate);

    List<PersonDeviceFilterLog> list();

    List<Map<String, Object>> unusualStatistics(@Param("temperature")BigDecimal temperature,@Param("startDate")String startDate,@Param("endDate")String endDate);

    PersonDeviceFilterLog get(Long id);
}
