package com.jpsoft.smart.modules.base.service;

import cn.hutool.json.JSONObject;
import com.github.pagehelper.Page;
import com.jpsoft.smart.modules.base.entity.PersonDeviceFilterLog;
import com.jpsoft.smart.modules.common.dto.Sort;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author 墨鱼_mo
 * @date 2020-3-20 9:13
 */
public interface PersonDeviceFilterLogService {

    /**
     * 设备自动上传的时间段过人记录
     * @param deviceNo
     * @param temperature
     * @param faceImageJson
     * @param libMatInfoListJson
     * @param matchPersonInfo
     */
    void deviceInsertFilterLog(String deviceNo, BigDecimal temperature, JSONObject faceImageJson, JSONObject libMatInfoListJson, JSONObject matchPersonInfo, Date date);

    Page<PersonDeviceFilterLog> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize, boolean count, List<Sort> sortList);

    List<PersonDeviceFilterLog> findByPersonAndDate(Long personId,String startDate,String endDate);

    List<PersonDeviceFilterLog> list();

    List<PersonDeviceFilterLog> temperatureNormalStatistics(BigDecimal temperature,String startDate,String endDate);

    List<PersonDeviceFilterLog> temperatureUnusualStatistics(BigDecimal temperature,String startDate,String endDate);

    List<Map<String, Object>> unusualStatistics(BigDecimal temperature,String startDate,String endDate);

    PersonDeviceFilterLog get(Long id);
}
