package com.jpsoft.smart.modules.common.utils;

import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.oss.common.utils.HttpUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.HttpEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpDelete;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Date;
import java.util.HashMap;

/**
 * @author 墨鱼_mo
 * @date 2020-3-14 16:43
 */
@Slf4j
@Component
public class LApiUtil {


    public static JSONObject PostRequest(String url,HashMap map){


        String body = HttpRequest.post(url).body(new JSONObject(map).toJSONString()).execute().body();
        JSONObject jsonbody = JSONObject.parseObject(body);
        return jsonbody;


    }

    public static JSONObject GetRequest(String url) throws Exception{

        String body = HttpRequest.get(url).execute().body();
        JSONObject jsonbody = JSONObject.parseObject(body);
        return jsonbody;


    }
    public static JSONObject DeletRequest(String url) {
       String body = HttpRequest.delete(url).execute().body();
       JSONObject jsonbody = JSONObject.parseObject(body);
       return jsonbody;


    }

    public static JSONObject putRequest(String url){
        String body = HttpRequest.put(url).execute().body();
        JSONObject jsonbody = JSONObject.parseObject(body);
        return jsonbody;
    }

    public static JSONObject putRequest(String url,HashMap map){
        String body = HttpRequest.put(url).body(new JSONObject(map).toJSONString()).execute().body();
        JSONObject jsonbody = JSONObject.parseObject(body);
        return jsonbody;
    }




    public static JSONObject getResponse(JSONObject dataJson) throws Exception{

        if (dataJson.getInteger("ResponseCode") == 1){
            throw new Exception("通用错误");
        }
        if (dataJson.getInteger("ResponseCode") == 2){
            throw new Exception("参数非法");
        }
        if (dataJson.getInteger("ResponseCode") == 3){
            throw new Exception("用户无权限");
        }
        if (dataJson.getInteger("ResponseCode") == 4){
            throw new Exception("设备不支持");
        }
        if (dataJson.getInteger("ResponseCode") == 5){
            throw new Exception("用户状态异常");
        }
        if (dataJson.getInteger("StatusCode") == 1){
            throw new Exception("执行失败");
        }
        if (dataJson.getInteger("StatusCode") == 2){
            throw new Exception("输入参数非法");
        }
        if (dataJson.getInteger("StatusCode") == 3){
            throw new Exception("系统内存不足");
        }
        if (dataJson.getInteger("StatusCode") == 8){
            throw new Exception("功能不支持");
        }
        if (dataJson.getInteger("StatusCode") == 10){
            throw new Exception("序列化执行失败");
        }
        if (dataJson.getInteger("StatusCode") == 11){
            throw new Exception("Basic 鉴权失败");
        }
        if (dataJson.getInteger("StatusCode") == 12){
            throw new Exception("Digest 鉴权失败");
        }
        if (dataJson.getInteger("StatusCode") == 13){
            throw new Exception("订阅已满");
        }
        if (dataJson.getInteger("StatusCode") == 14){
            throw new Exception("重复订阅");
        }

        return dataJson.getJSONObject("Data");
    }

    public static String getMatchMsg(Integer matchStatus){
        String matchMsg = "";
        if (matchStatus ==1){
            matchMsg = "核验成功";
        }
        else if (matchStatus == 2){
            matchMsg = "对比失败";
        }
        else if (matchStatus == 3){
            matchMsg = "对比成功，不在布控时间";
        }
        else if (matchStatus == 10){
            matchMsg = "对比成功，人脸属性异常";
        }
        else {
            matchMsg = "未知匹配消息";
        }

        return matchMsg;
    }

    public static Integer imageSize(String imageBase64Str){

        //1.找到等号，把等号也去掉(=用来填充base64字符串长度用)
        Integer equalIndex= imageBase64Str.indexOf("=");
        if(imageBase64Str.indexOf("=")>0) {
            imageBase64Str=imageBase64Str.substring(0, equalIndex);
        }
        //2.原来的字符流大小，单位为字节
        Integer strLength=imageBase64Str.length();
     //   System.out.println("imageBase64Str Length = "+strLength);
        //3.计算后得到的文件流大小，单位为字节
        Integer size=strLength-(strLength/8)*2;
        return size;
    }

    public static Integer getPersonCode(cn.hutool.json.JSONObject libMatInfoListJson, cn.hutool.json.JSONObject matchPersonInfo){
        if (!libMatInfoListJson.getStr("MatchPersonID").equals("0") && org.apache.commons.lang3.StringUtils.isNotBlank(matchPersonInfo.getStr("PersonCode"))){
            return matchPersonInfo.getInt("PersonCode");

        }else if (!libMatInfoListJson.getStr("MatchPersonID").equals("0") && org.apache.commons.lang3.StringUtils.isBlank(matchPersonInfo.getStr("PersonCode")) && StringUtils.isNotBlank(matchPersonInfo.getStr("PersonName"))){
            String personName = matchPersonInfo.getStr("PersonName");
            if (personName.contains("_")){
                log.warn(personName+"校验成功但未找到personCode");
                Integer personId =Integer.valueOf(personName.substring(personName.indexOf("_")+1)) ;
                return personId;
            }else {
                log.warn(personName+"校验成功但姓名中无personCode后缀");
                return 0;
            }


        }

        else {
            return 0;
        }
    }

    public static boolean compareToInterval(BigDecimal bigDecimal, Integer min,Integer max){
        if (bigDecimal.compareTo(new BigDecimal(min))==-1 || bigDecimal.compareTo(new BigDecimal(max)) ==1){
            return false;
        }
        else {
            return true;
        }

    }



    public static void main(String[] args) {
     //   Date date = new Date(1584405803000L);
    //    Date date = new
     //   Date date = new Date();
      // long time = date.getTime();
     //   System.out.println(date);
      //  192.168.11.13:80/V1.0/PeopleLibraries/1584409665/People/1111?LastChange=1584428390872
        boolean success = LApiUtil.compareToInterval(new BigDecimal(36.3),36,37);
        System.out.println(success);

    }



}

